/*
	Component Definitions
	on the Philips Chip LPC2106

	By Peter Eordegh
*/

//TaltOS IDs
#define TALTOS_ID1 (0x0000014E)
#define TALTOS_ID2 (0x0000014E)

//TaltOS public functions
#define TALTOS_RUN_AND_LIST_COMPONENTS_TASK	(0x00000005)
#define TALTOS_ADD_TASK					(0x00000008)
#define TALTOS_GET_COMPONENT_ADDRESS	(0x00000009)
#define TALTOS_GET_COMPONENT_FUNCTION	(0x0000000A)
#define TALTOS_LONG_OUTPUT_WRITE		(0x0000000B)

#define COMP_INIT						(0x00000000)

//Booleans
#define TALTOS_TRUE		(1)
#define TALTOS_FALSE	(0)

//TaltOS_run_and_list_components controllers
#define TALTOS_RUN_AND_LIST_SHOULDLIST	(0x00000001)
#define TALTOS_RUN_AND_LIST_SHOULDRUN	(0x00000002)

//Debug Macro
#define DEBUG(X) REG8(UART0_THR) = X;

typedef struct
{
	unsigned long TaltOS_get_component_address_ptr;
	unsigned long TaltOS_get_component_function_ptr;
	unsigned long argument;
} TaltOS_task_parameters;

//Get the component's address by it's ID (Absolute address)
typedef unsigned long*(*Tgca_t)(unsigned long id1, unsigned long id2);

//Get the component's n. function's pointer (Absolute address)
typedef unsigned long (*Tgcf_t)(unsigned long* address, unsigned long index);

//The output buffer's input function, can be called by the tasks to send data out of system
typedef void (*Tlow_t)(unsigned long inlong);


#define COMPONENT_HE_CRLF		(0x45480D0A)	// "HE" than CR and LF for : Hehe, this is working

